<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\DataSet;

class SelectOperador extends CrudWithParameterBag {
    
    protected $dataSourceName = 'select_operador';
    protected $dataSourceNameComFilial = 'select_operador_por_filial';
    protected $dataSourceNameSemFilial = 'select_operador_sem_filial';
    protected $dataSourceNameSemNotIn = 'select_operador_not_in';
    protected $dataSourceOperadorByFilial = 'select_operador_mult_filial';
    protected $dataSourceOperadorByVendedor = 'select_operador_vendedor';
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag,EntityManager $entityManager,Utilities\Util $util) {
        $this->entityManager = $entityManager;
        $this->util = $util;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function findOperadorByFilial($request, $response){
        $this->dataSourceName = $this->dataSourceOperadorByFilial;
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL');
        parent::find($request,$response);
    }
    
      public function findOperadorByVendendor($request, $response){
        $this->dataSourceName = $this->dataSourceOperadorByVendedor;
        $conditions = $this->util->getParamsAsArray($request);
        $NRORG = $conditions['NRORG'];
        $params = array(
         	':NRORG' => $NRORG,
 		);
        $resul = $this->entityManager->getConnection()->fetchAll(self::GET_OPERADOR, $params);
        $response->addDataSet(new DataSet("vnd06400_cadvendedor", $resul));
        return $response;

    }
    

    public function findSemFilial($request,$response) {
        $this->dataSourceName = $this->dataSourceNameSemFilial;
        $this->parameterBagColumns = array('NRORG', 'CDGRUPOPER');
        parent::find($request,$response);
    }

    public function findPorFilial($request,$response) {
        $this->dataSourceName = $this->dataSourceNameComFilial;
        
        parent::find($request,$response);
    }
    
    public function findNotIn($request,$response) {
        $this->dataSourceName = $this->dataSourceNameSemNotIn;
        $this->parameterBagColumns = array('NRORG', 'CDOPERADOR');
        parent::find($request,$response);
    }
    
    const GET_OPERADOR = "
        SELECT DISTINCT
            O.CDOPERADOR,
            O.NMOPERADOR,
            O.CDOPERADOR
            || ' - '
            || O.NMOPERADOR AS LABELOPERADOR,
            O.NRORG,
            O.IDATIVO
        FROM
            OPERADOR O
        WHERE
            O.CDOPERADOR NOT IN (
                SELECT DISTINCT
                    V.CDOPERADOR
                FROM
                    VENDEDOR V
                WHERE
                    V.CDOPERADOR IS NOT NULL
            )
        ORDER BY
            1,
            2,
            3
        ";
}



